From: David Bremner <david@tethera.net>
To: notmuch@notmuchmail.org
Cc: David Bremner <david@tethera.net>
Subject: [PATCH 04/13] test: add known broken test for n_directory_get_child_directories
Date: Sun, 26 Jul 2020 08:59:22 -0300 [thread overview]
Message-ID: <20200726115931.1448056-5-david@tethera.net> (raw)
In-Reply-To: <20200726115931.1448056-1-david@tethera.net>
The error message here may need adjusting.
---
test/T563-lib-directory.sh | 61 ++++++++++++++++++++++++++++++++++++++
1 file changed, 61 insertions(+)
create mode 100755 test/T563-lib-directory.sh
diff --git a/test/T563-lib-directory.sh b/test/T563-lib-directory.sh
new file mode 100755
index 00000000..e9e4cd0f
--- /dev/null
+++ b/test/T563-lib-directory.sh
@@ -0,0 +1,61 @@
+#!/usr/bin/env bash
+test_description="notmuch_database_* API"
+
+. $(dirname "$0")/test-lib.sh || exit 1
+
+add_email_corpus
+
+test_begin_subtest "building database"
+test_expect_success "NOTMUCH_NEW"
+
+cat <<EOF > c_head
+#include <stdio.h>
+#include <notmuch.h>
+#include <notmuch-test.h>
+#include <talloc.h>
+int main (int argc, char** argv)
+{
+ notmuch_database_t *db;
+ notmuch_directory_t *dir;
+ notmuch_status_t stat = NOTMUCH_STATUS_SUCCESS;
+ char *msg = NULL;
+
+ stat = notmuch_database_open_verbose (argv[1], NOTMUCH_DATABASE_MODE_READ_WRITE, &db, &msg);
+ if (stat != NOTMUCH_STATUS_SUCCESS) {
+ fprintf (stderr, "error opening database: %d %s\n", stat, msg ? msg : "");
+ exit (1);
+ }
+
+ EXPECT0(notmuch_database_get_directory (db, "", &dir));
+ EXPECT0(notmuch_database_close (db));
+EOF
+
+cat <<'EOF' > c_tail
+ if (stat) {
+ const char *stat_str = notmuch_database_status_string (db);
+ if (stat_str)
+ fputs (stat_str, stderr);
+ }
+
+}
+EOF
+
+test_begin_subtest "get child directories for a closed db"
+test_subtest_known_broken
+cat c_head - c_tail <<'EOF' | test_C ${MAIL_DIR}
+ {
+ notmuch_filenames_t *children;
+ children = notmuch_directory_get_child_directories (dir);
+ printf ("%d\n", children == NULL);
+ stat = NOTMUCH_STATUS_XAPIAN_EXCEPTION;
+ }
+EOF
+cat <<EOF > EXPECTED
+== stdout ==
+1
+== stderr ==
+A Xapian exception occurred at lib/directory.cc:XXX: Database has been closed
+EOF
+test_expect_equal_file EXPECTED OUTPUT
+
+test_done
--
2.27.0
next prev parent reply other threads:[~2020-07-26 12:01 UTC|newest]
Thread overview: 17+ messages / expand[flat|nested] mbox.gz Atom feed top
2020-07-26 11:59 final(?) batch of api cleanup for exception handling David Bremner
2020-07-26 11:59 ` [PATCH 01/13] test: add regression test for n_messages_collect_tags David Bremner
2020-07-26 11:59 ` [PATCH 02/13] test: split header for lib-message tests David Bremner
2020-07-26 11:59 ` [PATCH 03/13] test: regression test for n_m_get_filenames David Bremner
2020-07-26 11:59 ` David Bremner [this message]
2020-07-26 11:59 ` [PATCH 05/13] lib: catch exceptions in n_directory_get_child_directories David Bremner
2020-07-26 11:59 ` [PATCH 06/13] test: add known broken test for n_directory_get_child_files David Bremner
2020-07-26 11:59 ` [PATCH 07/13] lib: catch exceptions in n_directory_get_child_files David Bremner
2020-07-26 11:59 ` [PATCH 08/13] test: regression test for n_directory_delete with closed db David Bremner
2020-07-27 0:55 ` [PATCH 1/2] test: known broken " David Bremner
2020-07-27 0:55 ` [PATCH 2/2] lib: fix return value for n_directory_delete David Bremner
2020-07-27 12:06 ` [PATCH 08/13] test: regression test for n_directory_delete with closed db David Bremner
2020-07-26 11:59 ` [PATCH 09/13] test: regression test for n_directory_{get,set}_mtime David Bremner
2020-07-26 11:59 ` [PATCH 10/13] test: regression test for n_d_get_config_list on closed db David Bremner
2020-07-26 11:59 ` [PATCH 11/13] test: regression test for traversing config list with " David Bremner
2020-07-26 11:59 ` [PATCH 12/13] test: regression tests for n_indexopts_{get,set}_decrypt_policy David Bremner
2020-07-26 11:59 ` [PATCH 13/13] lib: return NULL from n_d_get_default_indexopts on error David Bremner
Reply instructions:
You may reply publicly to this message via plain-text email
using any one of the following methods:
* Save the following mbox file, import it into your mail client,
and reply-to-all from there: mbox
Avoid top-posting and favor interleaved quoting:
https://en.wikipedia.org/wiki/Posting_style#Interleaved_style
List information: https://notmuchmail.org/
* Reply using the --to, --cc, and --in-reply-to
switches of git-send-email(1):
git send-email \
--in-reply-to=20200726115931.1448056-5-david@tethera.net \
--to=david@tethera.net \
--cc=notmuch@notmuchmail.org \
/path/to/YOUR_REPLY
https://kernel.org/pub/software/scm/git/docs/git-send-email.html
* If your mail client supports setting the In-Reply-To header
via mailto: links, try the mailto: link
Be sure your reply has a Subject: header at the top and a blank line
before the message body.
Code repositories for project(s) associated with this public inbox
https://yhetil.org/notmuch.git/
This is a public inbox, see mirroring instructions
for how to clone and mirror all data and code used for this inbox;
as well as URLs for read-only IMAP folder(s) and NNTP newsgroup(s).